Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.netty.handler.codec.http
Class HttpContentEncoder

    java.lang.Object
      org.jboss.netty.channel.SimpleChannelHandler
          org.jboss.netty.handler.codec.http.HttpContentEncoder

All Implemented Interfaces:
  ChannelDownstreamHandler, ChannelHandler, ChannelUpstreamHandler

Direct Known Subclasses:
  HttpContentCompressor

    public abstract class HttpContentEncoder

extends SimpleChannelHandler

Encodes the content of the outbound `HttpResponse` and `HttpChunk`. The original content is replaced with the new content encoded by the `EncoderEmbedder`, which is created by `newContentEncoder(String)`. Once encoding is finished, the value of the `'Content-Encoding'` header is set to the target content encoding, as returned by `getTargetContentEncoding(String)`. Also, the `'Content-Length'` header is updated to the length of the encoded content. If there is no supported encoding in the corresponding `HttpRequest`'s `"Accept-Encoding"` header, `newContentEncoder(String)` should return `null` so that no encoding occurs (i.e. pass-through).

Please note that this is an abstract class. You have to extend this class and implement `newContentEncoder(String)` and `getTargetContentEncoding(String)` properly to make this class functional. For example, refer to the source code of `HttpContentCompressor`.

This handler must be placed after `HttpMessageEncoder` in the pipeline so that this handler can intercept HTTP responses before `HttpMessageEncoder` converts them into `ChannelBuffer`s.

Version:
  $Rev: 2368 $, $Date: 2010-10-18 17:19:03 +0900 (Mon, 18 Oct 2010) $
Author:
  The Netty Project, Trustin Lee

Nested Class Summary

Nested classes/interfaces inherited from interface org.jboss.netty.channel.ChannelHandler
`ChannelHandler.Sharable`

Constructor Summary
`protected` | `HttpContentEncoder()` Creates a new instance.

Method Summary
`protected abstract String` | `getTargetContentEncoding(String acceptEncoding)` Returns the expected content encoding of the encoded content.
`void` | `messageReceived(ChannelHandlerContext ctx, MessageEvent e)` Invoked when a message object (e.g: `ChannelBuffer`) was received from a remote peer.
`protected abstract EncoderEmbedder<ChannelBuffer>` | `newContentEncoder(String acceptEncoding)` Returns a new `EncoderEmbedder` that encodes the HTTP message content.
`void` | `writeRequested(ChannelHandlerContext ctx, MessageEvent e)` Invoked when `Channel.write(Object)` is called.

Methods inherited from class org.jboss.netty.channel.SimpleChannelHandler
`bindRequested, channelBound, channelClosed, channelConnected, channelDisconnected, channelInterestChanged, channelOpen, channelUnbound, childChannelClosed, childChannelOpen, closeRequested, connectRequested, disconnectRequested, exceptionCaught, handleDownstream, handleUpstream, setInterestOpsRequested, unbindRequested, writeComplete`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HttpContentEncoder

    protected HttpContentEncoder()

  Creates a new instance.

Method Detail

### messageReceived

    public void messageReceived(ChannelHandlerContext ctx,
                                MessageEvent e)
                         throws Exception

  Description copied from class: `SimpleChannelHandler`
  Invoked when a message object (e.g: `ChannelBuffer`) was received from a remote peer.

  Overrides:
    `messageReceived` in class `SimpleChannelHandler`
  Throws:
    `Exception`

### writeRequested

    public void writeRequested(ChannelHandlerContext ctx,
                               MessageEvent e)
                        throws Exception

  Description copied from class: `SimpleChannelHandler`
  Invoked when `Channel.write(Object)` is called.

  Overrides:
    `writeRequested` in class `SimpleChannelHandler`
  Throws:
    `Exception`

### newContentEncoder

    protected abstract EncoderEmbedder<ChannelBuffer> newContentEncoder(String acceptEncoding)
                                                                 throws Exception

  Returns a new `EncoderEmbedder` that encodes the HTTP message content.

  Parameters:
    `acceptEncoding` - the value of the `"Accept-Encoding"` header
  Returns:
    a new `EncoderEmbedder` if there is a supported encoding in `acceptEncoding`. `null` otherwise.
  Throws:
    `Exception`

### getTargetContentEncoding

    protected abstract String getTargetContentEncoding(String acceptEncoding)
                                                throws Exception

  Returns the expected content encoding of the encoded content.

  Parameters:
    `acceptEncoding` - the value of the `"Accept-Encoding"` header
  Returns:
    the expected content encoding of the new content
  Throws:
    `Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008-2010 JBoss, a division of Red Hat, Inc.. All Rights Reserved.